/****************************************************************************
 ****************************************************************************
 *
 * gpgwrap.c
 *
 ****************************************************************************
 ****************************************************************************/





#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "version.h"



#define PROGRAM_NAME			"gpgwrap"
#define VERSION_STRING			PROGRAM_NAME " " VERSION "-" VERSION_DATE



/****************************************************************************
 * do_perror
 ****************************************************************************/
static void
do_perror(
	void)

	{
	perror(PROGRAM_NAME);
	exit(1);
	}



/****************************************************************************
 * do_exit
 ****************************************************************************/
static void
do_exit(
	void)

	{
	char				space[] = VERSION_STRING;
	int				i;

	for (i = 0; space[i] != '\0'; i++) space[i] = ' ';
	printf(VERSION_STRING " | written by Karsten Scheibler\n"
		"%s | http://unusedino.de/gpgwrap/\n"
		"%s | gpgwrap@unusedino.de\n\n"
		"Usage: " PROGRAM_NAME " -p <file> gpg [gpg options]\n\n"
		"gpg will be executed with the --passphrase-fd option and\n"
		"the <file> opened\n", space, space);
	exit(0);
	}



/****************************************************************************
 * main
 ****************************************************************************/
int
main(
	int				argc,
	char				**argv)

	{
	int				fd;
	int				i, j, k;
	char				arg1[] = "--passphrase-fd";
	char				arg2[16];

	/* check cmdline parameters */

	if (argc < 4) do_exit();
	if (strcmp(argv[1], "-p") != 0) do_exit();

	/* open file containing the passphrase */

	if ((fd = open(argv[2], (O_RDONLY))) == -1) do_perror();

	/* create argv for execvp */

	snprintf(arg2, (sizeof (arg2) - 1), "%d", fd);
	for (i = 0, j = 3, k = 1; j < argc; j++, k--)
		{
		if (k == 0)
			{
			if ((strcmp(argv[j], "--homedir") != 0) && (strcmp(argv[j], "--options") != 0))
				{
				argv[i++] = arg1;
				argv[i++] = arg2;
				}
			else k = 2;
			}
		argv[i++] = argv[j];
		}
	if (k >= 0)
		{
		argv[i++] = arg1;
		argv[i++] = arg2;
		}
	argv[i] = NULL;
	execvp(argv[0], argv);

	/* only reached if execvp fails */

	do_perror();
	return (0);
	}
/******************************************************** Karsten Scheibler */
